
.. index::
   pair: Rust ; exa
   ! exa

.. _exa:

=================================
**exa** a modern version of ‘ls’
=================================


.. seealso::

   - https://github.com/ogham/exa
   - https://the.exa.website/

.. contents::
   :depth: 3

Rationale
===========

exa is a modern replacement for the command-line program ls that ships with
Unix and Linux operating systems, with more features and better defaults.

It uses colours to distinguish file types and metadata. It knows about symlinks,
extended attributes, and Git. And it’s small, fast, and just one single binary.

By deliberately making some decisions differently, exa attempts to be a more
featureful, more user-friendly version of ls


Options
==========

exa’s options are almost, but not quite, entirely unlike ``ls``'s.

Display Options
---------------

-  **-1**, **--oneline**: display one entry per line
-  **-G**, **--grid**: display entries as a grid (default)
-  **-l**, **--long**: display extended details and attributes
-  **-R**, **--recurse**: recurse into directories
-  **-T**, **--tree**: recurse into directories as a tree
-  **-x**, **--across**: sort the grid across, rather than downwards
-  **--colo[u]r**: when to use terminal colours
-  **--colo[u]r-scale**: highlight levels of file sizes distinctly

Filtering Options
-----------------

-  **-a**, **--all**: show hidden and 'dot' files
-  **-d**, **--list-dirs**: list directories like regular files
-  **-L**, **--level=(depth)**: limit the depth of recursion
-  **-r**, **--reverse**: reverse the sort order
-  **-s**, **--sort=(field)**: which field to sort by
-  **--group-directories-first**: list directories before other files
-  **-D**, **--only-dirs**: list only directories
-  **--git-ignore**: ignore files mentioned in ``.gitignore``
-  **-I**, **--ignore-glob=(globs)**: glob patterns (pipe-separated) of
   files to ignore

Pass the ``--all`` option twice to also show the ``.`` and ``..``
directories.

Long View Options
-----------------

These options are available when running with --long (``-l``):

-  **-b**, **--binary**: list file sizes with binary prefixes
-  **-B**, **--bytes**: list file sizes in bytes, without any prefixes
-  **-g**, **--group**: list each file's group
-  **-h**, **--header**: add a header row to each column
-  **-H**, **--links**: list each file's number of hard links
-  **-i**, **--inode**: list each file's inode number
-  **-m**, **--modified**: use the modified timestamp field
-  **-S**, **--blocks**: list each file's number of file system blocks
-  **-t**, **--time=(field)**: which timestamp field to use
-  **-u**, **--accessed**: use the accessed timestamp field
-  **-U**, **--created**: use the created timestamp field
-  \*\*@\*\*, **--extended**: list each file's extended attributes and
   sizes
-  **--git**: list each file's Git status, if tracked or ignored
-  **--time-style**: how to format timestamps

-  Valid **--color** options are **always**, **automatic**, and
   **never**.
-  Valid sort fields are **accessed**, **created**, **extension**,
   **Extension**, **inode**, **modified**, **name**, **Name**, **size**,
   **type**, and **none**. Fields starting with a capital letter sort
   uppercase before lowercase. The modified field has the aliases
   **date**, **time**, and **newest**, while its reverse has the aliases
   **age** and **oldest**.
-  Valid time fields are **modified**, **accessed**, and **created**.
-  Valid time styles are **default**, **iso**, **long-iso**, and
   **full-iso**.
